import QtQuick
import QtQuick.Controls.impl
import QtQuick.Templates as T

import Artix.Gui
import Artix.Core

/**
 * @brief Кнопка "переключатель"
 */
T.RadioButton {
    id: control
    Style.type: "radioButton"
    Style.class: "default"

    implicitWidth: Math.max(implicitBackgroundWidth + leftInset + rightInset,
                            implicitContentWidth + leftPadding + rightPadding)
    implicitHeight: Math.max(implicitBackgroundHeight + topInset + bottomInset,
                             implicitContentHeight + topPadding + bottomPadding,
                             implicitIndicatorHeight + topPadding + bottomPadding)

    padding: 6
    spacing: 6

    indicator: Rectangle {
        implicitWidth: 26
        implicitHeight: 26
        anchors {
            left: control.mirrored ? undefined : control.left
            right: !control.mirrored ? undefined : control.right
            verticalCenter: parent.verticalCenter
        }

        radius: width / 2
        color: control.Style.background.color
        border {
            width: control.Style.background.border.width
            color: control.Style.background.border.color
        }

        Rectangle {
            x: (parent.width - width) / 2
            y: (parent.height - height) / 2
            width: 12; height: 12
            radius: width / 2
            border {
                width: control.Style.content.border.width
                color: control.Style.content.border.color
            }
            color: control.Style.content.color
            visible: control.checked
        }

        Behavior on color { ColorAnimation { duration: 200 } }
    }

    contentItem: CheckLabel {
        leftPadding: !control.mirrored ? control.indicator.width + control.spacing : 0
        rightPadding: control.mirrored ? control.indicator.width + control.spacing : 0
        text: control.text
        font: control.Style.text.font
        color: control.Style.text.color
    }
}
